Search results

Accessibility in JavaScript (ES5) Range Slider control

08 May 2023 / 3 minutes to read

The Slider is characterized with complete ARIA Accessibility support that helps to access by on-screen readers and other assistive technology devices. This control is designed with the reference of guidelines document given in the WAI ARAI Accessibility Practices.

The Slider control uses the Slider role and the following ARIA properties for its element based on the state.

Property Functionalities
aria-valuenow It Indicates the current value of the slider.
aria-valuetext Returns the current text of the slider.
aria-valuemin It Indicates the Minimum value of the slider.
aria-valuemax It Indicates the Maximum value of the slider.
aria-orientation It Indicates the Slider Orientation.
aria-label Slider left and right button label text (increment and decrement).
aria-labelledby It indicates the name of the Slider.

Keyboard interaction

The Keyboard interaction of the Slider control is designed based on the WAI-ARIA Practices described for Slider. Users can use the following shortcut keys to interact with the Slider.

Keyboard shortcuts Actions
Right Arrow   |   Up Arrow Increase the Slider value.
Left Arrow   |   Down Arrow Decrease the Slider value.
Home Moves to the start value (for Range Slider when the second thumb is focused and the Home key is pressed, it moves to the first thumb value).
End Moves to the end value (for Range Slider when the first thumb is focused and the End key is pressed, it moves to the second thumb value).
Page Up Increases the Slider by `largeStep` value.
Page Down Decreases the Slider by `largeStep` value.
Source
Preview
index.js
index.html
index.css
Copied to clipboard
// Initialize Slider component
var minRangeObj = new ej.inputs.Slider({
    ticks: { placement: 'After', largeStep: 20, smallStep: 10, showSmallTicks: true },
    tooltip: { placement: 'Before', isVisible: true, showOn: 'Always' },
    value: 30,
    step: 10,
    type: 'MinRange',
    showButtons: true
});
// Render initialized Slider
minRangeObj.appendTo('#slider');
var weekdaysObj = new ej.inputs.Slider({
    min: 0, max: 6, step: 1, value: 2,
    // Assigning ticks data
    ticks: {
        placement: 'After',
        largeStep: 1,
    },
    renderingTicks: function (args) {
        // Weekdays Array
        var daysArr = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thrusday', 'Friday', 'Saturday'];
        // Customizing each ticks text into weeksdays
        args.value = daysArr[parseFloat(args.value)];
    },
    // Assigning tooltip data
    tooltip: {
        placement: 'Before',
        isVisible: true,
    },
    tooltipChange: function (args) {
        // Customizing tooltip to display the Day (in numeric) of the week
        args.tooltipText = 'Day ' + (Number(args.tooltipText) + 1).toString();
    }
});
// Render initialized Slider
weekdaysObj.appendTo('#slider1');
Copied to clipboard
<!DOCTYPE html><html lang="en"><head>
            
    <title>Essential JS 2 Slider</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 Slider Component">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-base/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-popups/styles/material.css" rel="stylesheet">
    <link href="//cdn.syncfusion.com/ej2/21.2.3/ej2-buttons/styles/material.css" rel="stylesheet">
    
    
<script src="https://cdn.syncfusion.com/ej2/21.2.3/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>
    
    <div id="container">
        
        <div class="wrap">
            <div class="label">Slider without formatted values</div>
            <div id="slider">
            </div>
        </div>
        
        <div class="wrap">
            <div class="label">Slider with formatted values</div>
            <div id="slider1">
            </div>
        </div>
    </div>


<script>
var ele = document.getElementById('container');
if(ele) {
    ele.style.visibility = "visible";
 }   
        </script>
<script src="index.js" type="text/javascript"></script>
</body></html>
Copied to clipboard
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  font-family: 'Helvetica Neue','calibiri';
  font-size: 14px;
  height: 40px;
  left: 45%;
  position: absolute;
  top: 45%;
  width: 30%;
}

.wrap {
  box-sizing: border-box;
  height: 100px;
  margin: 0 auto;
  padding: 30px 10px;
  width: 460px;
}

.wrap .label {
  text-align: center;
}

The Slider is characterized with complete ARIA Accessibility support that helps to access by on-screen readers and other assistive technology devices. This component is designed with the reference of guidelines document given in the WAI ARAI Accessibility Practices.
The Slider component uses the Slider
role and the following ARIA properties for its element based on the state.
Property | Functionalities |
---|---|
aria-valuenow | It Indicates the current value of the slider. |
aria-valuetext | Returns the current text of the slider. |
aria-valuemin | It Indicates the Minimum value of the slider. |
aria-valuemax | It Indicates the Maximum value of the slider. |
aria-orientation | It Indicates the Slider Orientation. |
aria-label | Slider left and right button label text (increment and decrement). |
aria-labelledby | It indicates the name of the Slider. |
The Keyboard interaction of the Slider component is designed based on the WAI-ARIA Practices described for Slider. Users can use the following shortcut keys to interact with the Slider.
Keyboard shortcuts | Actions |
Right Arrow | Up Arrow | Increase the Slider value. |
Left Arrow | Down Arrow | Decrease the Slider value. |
Home | Moves to the start value (for Range Slider when the second thumb is focused and the Home key is pressed, it moves to the first thumb value). |
End | Moves to the end value (for Range Slider when the first thumb is focused and the End key is pressed, it moves to the second thumb value). |
Page Up | Increases the Slider by `largeStep` value. |
Page Down | Decreases the Slider by `largeStep` value. |
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { SliderComponent } from '@syncfusion/ej2-react-inputs';
function App() {
let ticks01 = {
placement: "After",
largeStep: 20,
smallStep: 10,
showSmallTicks: true
};
let tooltip01 = { placement: "Before", isVisible: true, showOn: "Always" };
let ticks02 = { placement: "After", largeStep: 1 };
let tooltip02 = { placement: "Before", isVisible: true };
let value = 30;
let step = 10;
let showButtons = true;
function renderingTicksHandler(args) {
// Weekdays Array
let daysArr = [
"Sunday",
"Monday",
"Tuesday",
"Wednesday",
"Thrusday",
"Friday",
"Saturday"
];
// Customizing each ticks text into weeksdays
args.text = daysArr[parseFloat(args.value.toString())];
}
function tooltipChangeHandler(args) {
// Customizing tooltip to display the Day (in numeric) of the week
args.text = "Day " + (Number(args.value) + 1).toString();
}
return (<div id="container">
<div className="wrap">
<div className="label">Slider without formatted values</div>
<SliderComponent id="slider" step={step} value={value} tooltip={tooltip01} ticks={ticks01} type="MinRange" showButtons={true}/>
</div>
<div className="wrap">
<div className="label">Slider with formatted values</div>
<SliderComponent id="slider1" min={0} max={6} step={1} value={2} tooltip={tooltip02} ticks={ticks02} tooltipChange={tooltipChangeHandler.bind(this)} renderingTicks={renderingTicksHandler.bind(this)}/>
</div>
</div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));
<!DOCTYPE html>
<html lang="en">
<head>
<title>Syncfusion React ListView</title>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<meta name="description" content="Essential JS 2 for React Components" />
<meta name="author" content="Syncfusion" />
<link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-base/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-react-inputs/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-react-popups/styles/material.css" rel="stylesheet" />
<link href="//cdn.syncfusion.com/ej2/20.4.48/ej2-react-buttons/styles/material.css" rel="stylesheet" />
<link href="index.css" rel="stylesheet" />
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
<script src="systemjs.config.js"></script>
</head>
<body>
<div id='element'>
</div>
</body>
</html>
.sliderwrap {
margin-top: 20px;
}
.sliderwrap label {
font-size: 13px;
font-weight: 100;
margin-top: 15px;
padding-bottom: 15px;
}
.wrap {
box-sizing: border-box;
height: 100px;
margin: 0 auto;
padding: 30px 10px;
width: 460px;
}
.wrap .label {
text-align: center;
}
.labeltext {
text-align: center;
}
import * as React from 'react';
import * as ReactDOM from "react-dom";
import { SliderComponent } from '@syncfusion/ej2-react-inputs';
function App() {
let ticks01: TicksDataModel = {
placement: "After",
largeStep: 20,
smallStep: 10,
showSmallTicks: true
};
let tooltip01: TooltipDataModel = { placement: "Before", isVisible: true, showOn: "Always" };
let ticks02: TicksDataModel = { placement: "After", largeStep: 1 };
let tooltip02: TooltipDataModel = { placement: "Before", isVisible: true };
let value = 30;
let step = 10;
let showButtons = true;
function renderingTicksHandler(args: SliderTickEventArgs) {
// Weekdays Array
let daysArr: string[] = [
"Sunday",
"Monday",
"Tuesday",
"Wednesday",
"Thrusday",
"Friday",
"Saturday"
];
// Customizing each ticks text into weeksdays
args.text = daysArr[parseFloat(args.value.toString())];
}
function tooltipChangeHandler(args: SliderTooltipEventArgs) {
// Customizing tooltip to display the Day (in numeric) of the week
args.text = "Day " + (Number(args.value) + 1).toString();
}
return (
<div id="container">
<div className="wrap">
<div className="label">Slider without formatted values</div>
<SliderComponent
id="slider"
step={step}
value={value}
tooltip={tooltip01}
ticks={ticks01}
type="MinRange"
showButtons={true}
/>
</div>
<div className="wrap">
<div className="label">Slider with formatted values</div>
<SliderComponent
id="slider1"
min={0}
max={6}
step={1}
value={2}
tooltip={tooltip02}
ticks={ticks02}
tooltipChange={tooltipChangeHandler.bind(this) as any}
renderingTicks={renderingTicksHandler.bind(this) as any}
/>
</div>
</div>
);
}
export default App;
ReactDOM.render(<App />, document.getElementById('element'));

The Slider is characterized with complete ARIA Accessibility support that helps to access by on-screen readers and other assistive technology devices. This component is designed with the reference of guidelines document given in the WAI ARAI Accessibility Practices.
The Slider component uses the Slider
role and the following ARIA properties for its element based on the state.
Property | Functionalities |
---|---|
aria-valuenow | It Indicates the current value of the slider. |
aria-valuetext | Returns the current text of the slider. |
aria-valuemin | It Indicates the Minimum value of the slider. |
aria-valuemax | It Indicates the Maximum value of the slider. |
aria-orientation | It Indicates the Slider Orientation. |
aria-label | Slider left and right button label text (increment and decrement). |
aria-labelledby | It indicates the name of the Slider. |
The Keyboard interaction of the Slider component is designed based on the WAI-ARIA Practices described for Slider. Users can use the following shortcut keys to interact with the Slider.
Keyboard shortcuts | Actions |
Right Arrow | Up Arrow | Increase the Slider value. |
Left Arrow | Down Arrow | Decrease the Slider value. |
Home | Moves to the start value (for Range Slider when the second thumb is focused and the Home key is pressed, it moves to the first thumb value). |
End | Moves to the end value (for Range Slider when the first thumb is focused and the End key is pressed, it moves to the second thumb value). |
Page Up | Increases the Slider by `largeStep` value. |
Page Down | Decreases the Slider by `largeStep` value. |
import { Component } from '@angular/core';
@Component({
selector: 'my-app',
templateUrl: 'app/template.html',
styleUrls:['index.css']
})
export class AppComponent {
public tooltipData01: Object = { placement: 'Before', isVisible: true, showOn: 'Always' };
public ticksData01: Object = { placement: 'After', largeStep: 20, smallStep: 10, showSmallTicks: true };
public mintype: string = 'MinRange';
public tooltipData02: Object = { placement: 'Before', isVisible: true, showOn: 'Always' };
public ticksData02: Object = { placement: 'After', largeStep: 1 };
tooltipChangeHandler(args: SliderTooltipEventArgs): void {
// Weekdays Array
let daysArr: string [] = ['Sunday','Monday','Tuesday','Wednesday','Thrusday','Friday','Saturday'];
// Customizing each ticks text into weeksdays
args.text = daysArr[parseFloat(args.text)];
}
renderingTicksHandler(args: SliderTickEventArgs): void {
// Customizing tooltip to display the Day (in numeric) of the week
args.text = 'Day ' + (Number(args.text) + 1).toString();
}
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { SliderModule } from '@syncfusion/ej2-angular-inputs';
/**
* Module
*/
@NgModule({
imports: [
BrowserModule,
SliderModule
],
declarations: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';
enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);
<div id='container'>
<div class='wrap'>
<div class='label'>Slider without formatted values</div>
<ejs-slider id='slider' [type]="mintype" [min]=0 [max]=100 [value]=30 [step]=10 [tooltip]="tooltipData01" [ticks]="ticksData01"></ejs-slider>
</div>
<div class='wrap'>
<div class='label'>Slider with formatted values</div>
<ejs-slider id='slider1' [min]=0 [max]=6 [value]=2 [step]=1 [tooltip]="tooltipData02" [ticks]="ticksData02"
(tooltipChange)='tooltipChangeHandler($event)' (renderingTicks)='renderingTicksHandler($event)'></ejs-slider>
</div>
</div>
.wrap {
box-sizing: border-box;
height: 100px;
margin: 0 auto;
padding: 30px 10px;
width: 460px;
}
.wrap .label {
text-align: center;
}